SuperStrict
Const gw%=1024,gh%=768,scrtimer%=75,mapw%=500,maph%=500,tsze%=14,tktime%=5000,liquidspsl#=0.2,liquidmosp#=4.1
AppTitle="TRIBELIFE"'(c) by Lyssoft(2010)
Graphics gw,gh,0,60
SetBlend ALPHABLEND
SetMaskColor 255,0,255
SeedRnd MilliSecs()
AutoMidHandle 1
Incbin "Discognate.ttf"
Global actmousez%,font:TImageFont=LoadImageFont("incbin::Discognate.ttf",21),fontsmall:TImageFont=LoadImageFont("incbin::Discognate.ttf",16),lastscrx%,lastscry%,scrx%=mapw/2,scry%=maph/2,map%[gw+1,gh+1],liquid_gfx:TImage=LoadImage("gfx/liquid.png"),food_gfx:TImage=LoadImage("gfx/food.png"),creature_gfx:TImage=LoadImage("gfx/creature.png"),tribebase_gfx:TImage=LoadImage("gfx/tribebase.png"),Tilels:TList=New TList,objprels:TList=New TList,objls:TList=New TList,Tribels:TList=New TList,creals:TList=New TList,TriResls:TList=New TList,Foodls:TList=New TList,Liquidls:TList=New TList,choice$,actchoice%=1,tktimer%,mx%,my%,m1%,m2%,mapmx%,mapmy%,fpstimer:TTimer=CreateTimer(40),years%,newidtimer%,imgid%
SetImageFont(font)
Type Ttile
Field nr%,graphic:TImage
Function ReadTile(graphic$)
Local image:TImage=LoadImage("gfx/"+graphic)
If image
Local tile:Ttile=New Ttile
Tilels.AddLast(tile)
tile.graphic=LoadImage("gfx/"+graphic)
tile.nr=CountList(Tilels)
EndIf
EndFunction
Function Draw(nr%,X%,Y%)
For Local tile:Ttile=EachIn Tilels
If tile.nr=nr 
DrawImage tile.graphic,x*tsze,y*tsze
EndIf
Next
EndFunction
EndType
Type Tobjpre
Field mats$,images:TImage[],imgs%
EndType
Type Tobj
Field pre:Tobjpre,maxi%,avail%,img%,rot%,x%,y%
Function Create(x%,y%,ressource$,maxi%,imgid%)
Local obj:Tobj=New Tobj
objls.AddLast(obj)
For Local parent:Tobjpre=EachIn objprels
If parent.mats=ressource
obj.pre=parent
obj.img=imgid
Exit
EndIf
Next
obj.maxi=maxi
obj.avail=maxi
obj.rot=Rand(0,359)
obj.x=x
obj.y=y
EndFunction
Method Update()
SetRotation rot
SetAlpha avail/Float(maxi)
DrawImage pre.images[img],x-scrx*tsze,y-scry*tsze
SetAlpha 1.0
SetRotation 0
If avail<1 objls.Remove(Self)
EndMethod
Method tk()
If avail+maxi/15>maxi
avail=maxi
Else
avail=avail+maxi/15
EndIf
EndMethod
EndType
Type Ttribe
Field colr%,colg%,colb%,basex%,basey%,liquid%,food%,tribeid%,baserot%,maxage%,speed#,strength%,holdcap%,maxhealth%,ressourceusage%,pregnancy%,members%,getliquids%,getfoods%
Function Create()
Local tribe:Ttribe=New Ttribe
Tribels.AddLast(tribe)
tribe.tribeid=CountList(Tribels)
tribe.basex=mapmx
tribe.basey=mapmy
tribe.speed=Rand(10,20)
tribe.strength=Rand(1,10)
tribe.maxage=Rand(40,100)
tribe.holdcap=Rand(5,50)
tribe.maxhealth=Rand(10,25)
tribe.baserot=Rand(0,359)
tribe.colr=Rand(0,155);Delay 1
tribe.colg=Rand(0,155);Delay 1
tribe.colb=Rand(0,155)
tribe.ressourceusage=Ceil((tribe.speed/2+tribe.strength)/5+tribe.maxage/60+tribe.maxhealth/20+tribe.holdcap/10)/3
tribe.pregnancy=tribe.ressourceusage*3
tribe.liquid=50;tribe.food=50
For Local i%=1 To 5
Tcrea.Create(tribe,tribe.basex+Rand(-20,20),tribe.basey+Rand(-21,21))
Next
EndFunction
Method Update()
SetColor colr,colb,colg
SetRotation baserot
DrawImage tribebase_gfx,basex-scrx*tsze,basey-scry*tsze
SetRotation 0
SetColor 255,255,255
If Abs(mapmx-basex)<16 And Abs(mapmy-basey)<16
SetImageFont(fontsmall)
DrawText "Stammesmitglieder: "+members,mx,my-14
DrawText "Nahrung: "+food+" ("+getfoods+" Arbeitende)",mx,my
DrawText "Flssigkeiten: "+liquid+" ("+getliquids+" Arbeitende)",mx,my+14
SetImageFont(font)
EndIf
If food<0 food=0
If liquid<0 liquid=0
members=0;getliquids=0;getfoods=0
For Local crea:Tcrea=EachIn creals
If crea.tribe=Self 
members=members+1
If crea.go=1 Then getliquids=getliquids+1
If crea.go=2 Then getfoods=getfoods+1
EndIf
Next
If members=0 Tribels.Remove(Self)
EndMethod
EndType
Type Tcrea
Field tribe:Ttribe,health%,gender%,go%,age%,maxage%,x#,y#,movetimer%,holdressource$,rot%,preg%,working%[2],forcework%
Function Create(tribe:Ttribe,xp%,yp%)
Local crea:Tcrea=New Tcrea
creals.AddLast(crea)
crea.tribe=tribe
crea.age=0
crea.gender=Rand(0,1);Delay 1
crea.maxage=Rand(crea.tribe.maxage-crea.tribe.maxage/10,crea.tribe.maxage+crea.tribe.maxage/10)
crea.x=xp
crea.y=yp
crea.health=crea.tribe.maxhealth
EndFunction
Method Update()
Local r%=tribe.colr,g%=tribe.colg,b%=tribe.colb
If gender=0 
b=b+25
Else
r=r+25
b=b+25
EndIf
SetColor r,g,b
SetRotation rot+90
SetAlpha Float(health)/tribe.maxhealth
DrawImage creature_gfx,x-scrx*tsze,y-scry*tsze
SetAlpha 1.0
SetRotation 0
SetColor 255,255,255
If working[0]=0 And working[1]=0
If tribe.liquid<(tribe.members*tribe.ressourceusage)*10 
If tribe.liquid+tribe.getliquids*tribe.holdcap<(tribe.members*tribe.ressourceusage)*10 
For Local liquid:Tliquid=EachIn Liquidls
If working[0]=0 And working[1]=0
working[0]=liquid.x;working[1]=liquid.y
Else
If Abs(liquid.x-x)+Abs(liquid.y-y)<Abs(working[0]-x)+Abs(working[1]-y)
working[0]=liquid.x;working[1]=liquid.y
EndIf
EndIf
Next
EndIf
EndIf
If working[0]<>0 And working[1]<>0 go=1
EndIf
If working[0]=0 And working[1]=0
If tribe.food<(tribe.members*tribe.ressourceusage)*10
If tribe.food+tribe.getfoods*tribe.holdcap<(tribe.members*tribe.ressourceusage)*10
For Local food:Tfood=EachIn Foodls
If working[0]=0 And working[1]=0
working[0]=food.x;working[1]=food.y
Else
If Abs(food.x-x)+Abs(food.y-y)<Abs(working[0]-x)+Abs(working[1]-y)
working[0]=food.x;working[1]=food.y
EndIf
EndIf
Next
EndIf
EndIf
If working[0]<>0 And working[1]<>0 go=2
EndIf
If age>tribe.maxage/10 And age<tribe.maxage/1.5
If preg=0 And gender=0 And working[0]=0 And working[1]=0
working[0]=-1;working[1]=-1
EndIf
EndIf
If working[0]>0 And working[1]>0
rot=(360+ATan2(working[1]-y,working[0]-x))Mod 360
If MilliSecs()>movetimer
If Abs(x-working[0])<2 And Abs(y-working[1])<2
x=working[0];y=working[1]
Else
x=x+Cos(rot)
y=y+Sin(rot)
movetimer=MilliSecs()+1000/tribe.speed
EndIf
EndIf
ElseIf working[0] =-1 And working[1] =-1 
Local nearest%[2],crt:Tcrea
For Local check:Tcrea=EachIn creals
If check.tribe=tribe And check.gender<>gender And check.preg=0
If check.age>check.tribe.maxage/10 And check.age<check.tribe.maxage/1.5
If nearest[0]=0 And nearest[1]=0
nearest[0]=check.x;nearest[1]=check.y
crt=check
Else
If Abs(check.x-x)+Abs(check.y-y)<Abs(nearest[0]-x)+Abs(nearest[1]-y)
nearest[0]=check.x;nearest[1]=check.y
crt=check
EndIf
EndIf
EndIf
EndIf
Next
If nearest[0]<>0 And nearest[1]<>0 
rot=(360+ATan2(nearest[1]-y,nearest[0]-x))Mod 360
If MilliSecs()>movetimer
If Abs(x-nearest[0])<4.0 And Abs(y-nearest[1])<4.0
crt.preg=tribe.pregnancy;preg=tribe.pregnancy/2
working[0]=0;working[1]=0
Else
x=x+Cos(rot)
y=y+Sin(rot)
movetimer=MilliSecs()+1000/tribe.speed
EndIf
EndIf
EndIf
EndIf
Local gres:Ttriberes
If working[0]=0 And working[1]=0
For Local obj:Tobj=EachIn objls
If Not gres
For Local resls:Ttriberes=EachIn TriResls
If resls.tribe=tribe And obj.pre=resls.ressource
gres=resls
EndIf
Next
EndIf
If Not gres gres=Ttriberes.Create(tribe,obj.pre)
If forcework=1
If working[0]=0 And working[1]=0
working[0]=obj.x;working[1]=obj.y
Else
If Abs(working[0]-x)+Abs(working[1]-y)>Abs(x-obj.x)+Abs(y-obj.y)
working[0]=obj.x;working[1]=obj.y
EndIf
EndIf
Else
If(gres.qut)<tribe.members*tribe.ressourceusage 
If working[0]=0 And working[1]=0 
working[0]=obj.x;working[1]=obj.y
Else
If Abs(working[0]-x)+Abs(working[1]-y)>Abs(x-obj.x)+Abs(y-obj.y)
working[0]=obj.x;working[1]=obj.y
EndIf
EndIf
EndIf
EndIf
Next
EndIf
If working[0]=0 And working[1]=0
forcework=1
Else
forcework=0
EndIf
If x=working[0] And y=working[1]
If x=tribe.basex And y=tribe.basey
If go=1
tribe.liquid=tribe.liquid+Int(Mid(holdressource,Instr(holdressource,Chr(134))+1))
ElseIf go=2
tribe.food=tribe.food+Int(Mid(holdressource,Instr(holdressource,Chr(134))+1))
Else
For Local resls:Ttriberes=EachIn TriResls
If Left(holdressource,Instr(holdressource,Chr(134))-1)=resls.ressource.mats
resls.qut=resls.qut+Int(Mid(holdressource,Instr(holdressource,Chr(134))+1))
EndIf
Next
EndIf
working[0]=0;working[1]=0;holdressource=""
Else
For Local liquid:Tliquid=EachIn Liquidls
If Abs(liquid.x-x)<2 And Abs(liquid.y-y)<2
liquid.mass=liquid.mass-tribe.holdcap
holdressource="liquid"+Chr(134)+tribe.holdcap
EndIf
Next
For Local food:Tfood=EachIn Foodls
If Abs(food.x-x)<2 And Abs(food.y-y)<2
food.avail=food.avail-tribe.holdcap
holdressource="food"+Chr(134)+tribe.holdcap
EndIf
Next
For Local obj:Tobj=EachIn objls
If Abs(obj.x-x)<2 And Abs(obj.y-y)<2
obj.avail=obj.avail-tribe.holdcap
holdressource=obj.pre.mats+Chr(134)+tribe.holdcap
EndIf
Next
working[0]=tribe.basex
working[1]=tribe.basey
EndIf
EndIf
If age>maxage Or health<1
creals.Remove(Self)
EndIf
EndMethod
Method tk()
age=age+1
If tribe.food <= 0 health=health-tribe.maxhealth/5
If tribe.liquid <= 0 health=health-tribe.maxhealth/5
tribe.food=tribe.food-tribe.ressourceusage
tribe.liquid=tribe.liquid-tribe.ressourceusage
For Local resls:Ttriberes=EachIn TriResls
If resls.tribe=tribe
If resls.qut>0
resls.qut=resls.qut-tribe.ressourceusage
health=health+tribe.ressourceusage*5
If preg>1 preg=preg/2
EndIf
EndIf
Next
If preg=1 And gender=1
Tcrea.Create(tribe,x,y)
EndIf
preg=preg-1
If preg<0 preg=0
EndMethod
EndType
Type Ttriberes
Field tribe:Ttribe,ressource:Tobjpre,qut%
Function Create:Ttriberes(t:Ttribe,r:Tobjpre)
Local tr:Ttriberes=New Ttriberes
TriResls.AddLast(tr)
tr.tribe=t
tr.ressource=r
Return tr
EndFunction
Method Update()
If qut<0 qut=0
EndMethod
EndType
Type Tfood
Field avail%,maxi%,x%,y%,rot%
Function Create(x%,y%,maxi%)
Local food:Tfood=New Tfood
Foodls.AddLast(food)
food.x=x
food.y=y
food.maxi=maxi
food.avail=maxi
food.rot=Rand(0,359)
EndFunction
Method Update()
If avail>maxi avail=maxi
SetAlpha Float(avail)/maxi
SetRotation rot
DrawImage food_gfx,x-scrx*tsze,y-scry*tsze
SetRotation 0
SetAlpha 1.0
If avail<1 Foodls.Remove(Self)
EndMethod
Method tk()
If avail+maxi/10>maxi
avail=maxi
Else
avail=avail+maxi/10
EndIf
EndMethod
EndType
Type Tliquid
Field mass%,splitmass%,colr%,colg%,colb%,x#,y#,mosp#,movedirection%,regid%
Method split()
If mass>splitmass
Local liquid:Tliquid=New Tliquid
Liquidls.AddLast(liquid)
liquid.regid=CountList(Liquidls)
liquid.mass=splitmass
liquid.splitmass=splitmass
liquid.colr=colr
liquid.colb=colb
liquid.colg=colg
liquid.x=x
liquid.y=y
liquid.movedirection=Rand(0,359)
liquid.mosp=Rand(0,liquidmosp)
mass=mass-splitmass
EndIf
EndMethod
Method tk()
If mass+splitmass/20<splitmass 
mass=mass+splitmass/20
Else
mass=splitmass
EndIf
EndMethod
Method combine()
For Local check:Tliquid=EachIn Liquidls
If check.regid<>regid
If check.mass <= check.splitmass
If check.mosp <= 0.0 And mosp <= 0.0
If Abs(check.x-x)<2.0 And Abs(check.y-y)<2.0
If check.colb=colb And check.colg=colg And check.colr=colr
If check.splitmass=splitmass
mass=mass+check.mass
Liquidls.Remove(check)
EndIf
EndIf
EndIf
EndIf
EndIf
EndIf
Next
EndMethod
Method Update()
combine()
split()
If mosp>0.0
x=x+Cos(movedirection)*liquidspsl
y=y+Sin(movedirection)*liquidspsl
mosp=mosp-liquidspsl
EndIf
SetAlpha Float(mass)/splitmass
SetColor colr,colg,colb
DrawImage liquid_gfx,x-scrx*tsze,y-scry*tsze
SetAlpha 1.0
SetColor 255,255,255
EndMethod
Function Create(x%,y%,ma%,spma%,r%,g%,b%)
Local Liquid:Tliquid=New Tliquid
Liquidls.AddLast(liquid)
liquid.regid=CountList(Liquidls)
liquid.x=x
liquid.y=y
liquid.mass=ma
liquid.splitmass=spma
liquid.colr=r
liquid.colg=g
liquid.colb=b
EndFunction
EndType
Local tiles:TStream=ReadFile("data/tiles.ini")
While Not Eof(tiles)
Ttile.ReadTile(ReadLine(tiles))
Wend
CloseFile tiles
For Local y%=0 To gh
For Local x%=0 To gw
map[x,y]=Rand(1,CountList(Tilels))
Next
Next
importobjs()
Repeat
mx=MouseX();my=MouseY();mapmx=scrx*tsze+mx;mapmy=scry*tsze+my
m1=MouseHit(MOUSE_LEFT);m2=MouseHit(MOUSE_RIGHT);actchoice=actchoice+MouseZSpeed()
updategod()
updateenviroment()
choice=getchoice(actchoice)
SetColor 99,99,99
Local tx$="Jahre seit Anbeginn der Zeit: "+years
DrawRect 0,0,TextWidth(tx)+10,TextHeight("A")+1
DrawRect 0,TextHeight("A"),TextWidth("Ausgewhlt: "+choice)+5,TextHeight("A")+1
SetColor 122,122,122
DrawRect 0,0,TextWidth(tx)+9,TextHeight("A")
DrawRect 0,TextHeight("A"),TextWidth("Ausgewhlt: "+choice)+4,TextHeight("A")
SetColor 200,200,200
DrawText tx,0,0
DrawText "Ausgewhlt: "+choice,0,TextHeight("A")
SetColor 255,255,255
Flip 0
Cls
WaitTimer(fpstimer)
m1=0;m2=0
Until KeyHit(KEY_ESCAPE) Or AppTerminate()
Function updateenviroment()
If MilliSecs()>tktimer
years=years+1
tktimer=MilliSecs()+tktime
For Local tk:Tfood=EachIn Foodls
tk.Update()
Next
For Local tk:Tcrea=EachIn creals
tk.tk()
Next
For Local tk:Tliquid=EachIn Liquidls
tk.tk()
Next
For Local tk:Tobj=EachIn objls
tk.tk()
Next
EndIf
For Local liquid:Tliquid=EachIn Liquidls
liquid.Update()
Next
For Local food:Tfood=EachIn Foodls
food.Update()
Next
For Local tribe:Ttribe=EachIn Tribels
tribe.Update()
Next
For Local obj:Tobj=EachIn objls
obj.Update()
Next
For Local crea:Tcrea=EachIn creals
crea.Update()
Next
For Local resls:Ttriberes=EachIn TriResls
resls.Update()
Next
EndFunction
Function updategod()
If mx<gw/10
If MilliSecs()>lastscrx
If scrx-1>0 
scrx=scrx-1
lastscrx=lastscrx+scrtimer
EndIf
EndIf
ElseIf mx>gw-gw/10
If MilliSecs()>lastscrx
If scrx+1+gw/tsze<mapw
scrx=scrx+1
lastscrx=lastscrx+scrtimer
EndIf
EndIf
EndIf
If my<gh/10
If MilliSecs()>lastscry
If scry-1>0
scry=scry-1
lastscry=lastscry+scrtimer
EndIf
EndIf
ElseIf my>gh-gh/10
If MilliSecs()>lastscry
If scry+2+gh/tsze<maph
scry=scry+1
lastscry=lastscry+scrtimer
EndIf
EndIf
EndIf
For Local y%=scry To 1+scry+gh/tsze
For Local x%=scrx To 1+scrx+gw/tsze
If y>0 And y<maph
If x>0 And x<mapw
Ttile.Draw(map[x,y],x-scrx,y-scry)
EndIf
EndIf
Next
Next
EndFunction
Function importobjs()
Local getobj%=ReadDir("data/objects/"),data:TStream,imgs%
Repeat
Local dat$=NextFile(getobj)
If dat="" Exit
If Right(dat,4)=".ini" 
data=ReadFile("data/objects/"+dat)
imgs=0
Local objpre:Tobjpre=New Tobjpre
objprels.AddLast(objpre)
While Not Eof(data)
Local rl$=ReadLine(data)
If Left(rl,14)="ressourcename:" 
objpre.mats=Mid(rl,15)
ElseIf Left(rl,6)="image:" 
objpre.images=objpre.images[..(imgs+1)]
objpre.images[imgs]=LoadImage("gfx/"+Mid(rl,7))
imgs=imgs+1
EndIf
Wend
objpre.imgs=imgs-1
CloseFile data
EndIf
Forever
EndFunction
Function getchoice$(nr%)
Local dat:TStream=ReadFile("data/choice.ini"),searches%
While Not Eof(dat)
Local rline$=ReadLine(dat)
If Left(rline,1)="-"
searches=searches+1
If searches=nr
If Mid(rline,2)="liquid"
Local ma%=Int(ReadLine(dat))
Local spma%=Int(ReadLine(dat))
Local r%=Int(ReadLine(dat))
Local g%=Int(ReadLine(dat))
Local b%=Int(ReadLine(dat))
SetAlpha 0.5
SetColor r,g,b
DrawImage liquid_gfx,mx,my
SetAlpha 1.0
SetColor 255,255,255
If m1=1
Tliquid.Create(mapmx,mapmy,ma,spma,r,g,b)
EndIf
CloseFile dat
Return "Flssigkeit"
ElseIf Mid(rline,2)="food" 
If m1=1 Tfood.Create(mapmx,mapmy,Int(ReadLine(dat)))
SetAlpha 0.5
DrawImage food_gfx,mx,my
SetAlpha 1.0
CloseFile dat
Return "Nahrungsquelle"
ElseIf Mid(rline,2)="tribe" 
If m1=1 Ttribe.Create()
CloseFile dat
SetAlpha 0.5
SetColor 110,110,110
DrawImage tribebase_gfx,mx,my
SetColor 255,255,255
SetAlpha 1.0
Return "Neuer Stamm"
Else
If m1=1 Tobj.Create(mapmx,mapmy,Mid(rline,2),Int(ReadLine(dat)),imgid);newidtimer=0
CloseFile dat
SetAlpha 0.5
For Local chk:Tobjpre=EachIn objprels
If chk.mats=Mid(rline,2) 
If MilliSecs()>newidtimer 
newidtimer=MilliSecs()+1500
imgid=Rand(0,chk.imgs)
EndIf
DrawImage chk.images[imgid],mx,my
EndIf
Next
SetAlpha 1.0
Return Mid(rline,2)
EndIf
EndIf
EndIf
Wend
actchoice=1;choice=getchoice(actchoice)
CloseFile dat
EndFunction
Function MouseZSpeed%()
If actmousez<MouseZ() 
actmousez=MouseZ()
newidtimer=0
Return 1
ElseIf actmousez>MouseZ() 
actmousez=MouseZ()
newidtimer=0
Return-1
Else
Return 0
EndIf
EndFunction